run("Duplicate...", "title=RGOstack duplicate");

//Background subtraction, parameters were determined in the associated Excel file
getDimensions(width, height, channels, slices, frames);
for (i = 0; i < slices; i++) {
	lp = i+2; //laser power (%)
	//round 1, Red channel (Ch1)
	setSlice(i*3 + 1);
	bkg = 155.6 + 0.082*lp;
	run("Subtract...", "value=" + bkg + " slice");
	//round 2, Orange channel (Ch3)
	setSlice(i*3 + 3);
	bkg = 137.1 + 0.946*lp;
	run("Subtract...", "value=" + bkg + " slice");
}

run("Split Channels");
selectWindow("C2-RGOstack");
close();
selectWindow("C1-RGOstack");
run("Translate...", "x=-1 y=-1 interpolation=None stack");
selectWindow("C3-RGOstack");

//Making mask of labeled region
selectWindow("C1-RGOstack");
run("Duplicate...", "title=mask duplicate");
run("Auto Threshold", "method=Otsu white stack");
run("Divide...", "value=255 stack");
run("32-bit");
setMinAndMax(0, 1);

//put NaN on non-labeled pixels
imageCalculator("Multiply create 32-bit stack", "C1-RGOstack","mask");
selectWindow("C1-RGOstack");close();
setThreshold(1.0000, 1000000000000000000000000000000.0000);
run("NaN Background", "stack");

imageCalculator("Multiply create 32-bit stack", "C3-RGOstack","mask");
selectWindow("C3-RGOstack");close();
setThreshold(1.0000, 1000000000000000000000000000000.0000);
run("NaN Background", "stack");

selectWindow("mask");close();

//Measure ratio
run("Merge Channels...", "c1=[Result of C1-RGOstack] c2=[Result of C3-RGOstack] create");
Stack.setDisplayMode("grayscale");
rename("ROstack");

run("Clear Results");
for (i = 0; i < slices; i++) {
	setSlice(2*i + 1);//Red channel
	getStatistics(area, mean);
	Rmean = mean;
	setSlice(2*i + 2);//Orange channel
	getStatistics(area, mean);
	Omean = mean;
	ORratio = Omean/Rmean;
	setResult("LeakFactor", i, ORratio); 
}